package cn.iocoder.yudao.module.wealth.service.receiptItem;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.util.MyBatisUtils;
import cn.iocoder.yudao.module.wealth.dal.mysql.receiptItem.BankReceiptDetailsMapper;
import cn.iocoder.yudao.module.wealth.vo.receiptItem.ReceiptItemReq;
import cn.iocoder.yudao.module.wealth.vo.receiptItem.ReceiptItemResp;
import com.baomidou.mybatisplus.core.metadata.IPage;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;
import java.util.List;

/*
 lanbm 2024-05-18 add
 银行收款明细列表
 */
@Service
@Validated
@Slf4j
public class BankReceiptDetailsImpl implements BankReceiptDetailsService {

    @Resource
    private BankReceiptDetailsMapper bankReceiptDetailsMapper;


    /*
     获取分页数据
     */
    public PageResult<ReceiptItemResp> getBankReceiptDetailsList(ReceiptItemReq req) {
        IPage<ReceiptItemResp> mpPage = MyBatisUtils.buildPage(req);
        long total = bankReceiptDetailsMapper.GetCount(req);
        int start = (req.getPageNo() - 1) * req.getPageSize();

        req.setStart(start);

        List<ReceiptItemResp> list =
                bankReceiptDetailsMapper.getBankReceiptDetailsList(req);

        return new PageResult<>(list, total, mpPage.getSize(),
                req.getPageNo(), (total + mpPage.getSize() - 1) / mpPage.getSize());

    }
}
